cabal-version:      2.4
name:               unsigs-plutus
version:            0.1.0.0


license: Apache-2.0
license-files: LICENSE
author:             Adrian 
maintainer:         https://discord.com/channels/@adrian.#4706


flag defer-plugin-errors
    description:
        Defer errors from the plugin, useful for things like Haddock that can't handle it.
    default: False
    manual: True

common lang
    default-language:   Haskell2010
    ghc-options:
      -Wall -Wnoncanonical-monad-instances
      -Wincomplete-uni-patterns -Wincomplete-record-updates
      -Wredundant-constraints -Widentities 
      -- See Plutus Tx readme
      -fobject-code -fno-ignore-interface-pragmas -fno-omit-interface-pragmas
    if flag(defer-plugin-errors)
        ghc-options: -fplugin-opt PlutusTx.Plugin:defer-errors

library
    import: lang
    exposed-modules:
      Market.Offchain 
      Market.Types 
      Market.Onchain
      Market.Trace
      Utility
      SerialiseJSON 
    build-depends:
      base >= 4.9 && < 5,
      aeson,
      bytestring,
      containers,
      freer-extras,
      playground-common,
      plutus-contract,
      plutus-tx-plugin,
      plutus-tx,
      plutus-ledger,
      text,
      cardano-api,
      serialise,
      plutus-ledger-api,
      plutus-chain-index,
      data-default,
      plutus-use-cases,
      tasty,
    hs-source-dirs: src src/Market

executable unsigs-market-pab
  import: lang
  main-is: Main.hs
  hs-source-dirs: pab
  ghc-options:
    -threaded -rtsopts
  build-depends:
    base >= 4.9 && < 5,
    data-default -any,
    plutus-contract -any,
    plutus-pab -any,
    unsigs-plutus -any,
    aeson -any,
    freer-simple -any,
    prettyprinter -any,
    freer-extras -any,
    plutus-ledger -any,
    openapi3 -any,
    plutus-use-cases -any,
    bytestring -any

executable market-plutus
  default-language: Haskell2010
  hs-source-dirs:       app
  main-is:              market-plutus.hs
  ghc-options:          -threaded -rtsopts "-with-rtsopts=-T"

  build-depends:        cardano-api
                      , unsigs-plutus 
                      , plutus-ledger-api
                      , bytestring
                      , cardano-ledger-alonzo
                      , base


executable datum-json
  default-language: Haskell2010
  hs-source-dirs:       app
  main-is:              datum-json.hs
  ghc-options:          -threaded -rtsopts "-with-rtsopts=-T"

  build-depends:        unsigs-plutus
                      , bytestring
                      , cardano-api
                      , plutus-tx
                      , aeson
                      , base 

